Index: /trunk/source/Lib/TLibCommon/TComInterpolationFilter.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -47,4 +47,7 @@
 #include "TComChromaFormat.h"
 
+#if VECTOR_CODING__INTERPOLATION_FILTER && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+#include <emmintrin.h>
+#endif
 
 //! \ingroup TLibCommon
@@ -75,5 +78,106 @@
 };
 
-#if NH_3D_ARP
+#if VECTOR_CODING__INTERPOLATION_FILTER && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+inline __m128i simdInterpolateLuma4( Short const *src , Int srcStride , __m128i *mmCoeff , const __m128i & mmOffset , Int shift )
+{
+  __m128i sumHi = _mm_setzero_si128();
+  __m128i sumLo = _mm_setzero_si128();
+  for( Int n = 0 ; n < 8 ; n++ )
+  {
+    __m128i mmPix = _mm_loadl_epi64( ( __m128i* )src );
+    __m128i hi = _mm_mulhi_epi16( mmPix , mmCoeff[n] );
+    __m128i lo = _mm_mullo_epi16( mmPix , mmCoeff[n] );
+    sumHi = _mm_add_epi32( sumHi , _mm_unpackhi_epi16( lo , hi ) );
+    sumLo = _mm_add_epi32( sumLo , _mm_unpacklo_epi16( lo , hi ) );
+    src += srcStride;
+  }
+  sumHi = _mm_srai_epi32( _mm_add_epi32( sumHi , mmOffset ) , shift );
+  sumLo = _mm_srai_epi32( _mm_add_epi32( sumLo , mmOffset ) , shift );
+  return( _mm_packs_epi32( sumLo , sumHi ) );
+}
+
+inline __m128i simdInterpolateChroma4( Short const *src , Int srcStride , __m128i *mmCoeff , const __m128i & mmOffset , Int shift )
+{
+  __m128i sumHi = _mm_setzero_si128();
+  __m128i sumLo = _mm_setzero_si128();
+  for( Int n = 0 ; n < 4 ; n++ )
+  {
+    __m128i mmPix = _mm_loadl_epi64( ( __m128i* )src );
+    __m128i hi = _mm_mulhi_epi16( mmPix , mmCoeff[n] );
+    __m128i lo = _mm_mullo_epi16( mmPix , mmCoeff[n] );
+    sumHi = _mm_add_epi32( sumHi , _mm_unpackhi_epi16( lo , hi ) );
+    sumLo = _mm_add_epi32( sumLo , _mm_unpacklo_epi16( lo , hi ) );
+    src += srcStride;
+  }
+  sumHi = _mm_srai_epi32( _mm_add_epi32( sumHi , mmOffset ) , shift );
+  sumLo = _mm_srai_epi32( _mm_add_epi32( sumLo , mmOffset ) , shift );
+  return( _mm_packs_epi32( sumLo , sumHi ) );
+}
+
+inline __m128i simdInterpolateLuma8( Short const *src , Int srcStride , __m128i *mmCoeff , const __m128i & mmOffset , Int shift )
+{
+  __m128i sumHi = _mm_setzero_si128();
+  __m128i sumLo = _mm_setzero_si128();
+  for( Int n = 0 ; n < 8 ; n++ )
+  {
+    __m128i mmPix = _mm_loadu_si128( ( __m128i* )src );
+    __m128i hi = _mm_mulhi_epi16( mmPix , mmCoeff[n] );
+    __m128i lo = _mm_mullo_epi16( mmPix , mmCoeff[n] );
+    sumHi = _mm_add_epi32( sumHi , _mm_unpackhi_epi16( lo , hi ) );
+    sumLo = _mm_add_epi32( sumLo , _mm_unpacklo_epi16( lo , hi ) );
+    src += srcStride;
+  }
+  sumHi = _mm_srai_epi32( _mm_add_epi32( sumHi , mmOffset ) , shift );
+  sumLo = _mm_srai_epi32( _mm_add_epi32( sumLo , mmOffset ) , shift );
+  return( _mm_packs_epi32( sumLo , sumHi ) );
+}
+
+inline __m128i simdInterpolateLuma2P8( Short const *src , Int srcStride , __m128i *mmCoeff , const __m128i & mmOffset , Int shift )
+{
+  __m128i sumHi = _mm_setzero_si128();
+  __m128i sumLo = _mm_setzero_si128();
+  for( Int n = 0 ; n < 2 ; n++ )
+  {
+    __m128i mmPix = _mm_loadu_si128( ( __m128i* )src );
+    __m128i hi = _mm_mulhi_epi16( mmPix , mmCoeff[n] );
+    __m128i lo = _mm_mullo_epi16( mmPix , mmCoeff[n] );
+    sumHi = _mm_add_epi32( sumHi , _mm_unpackhi_epi16( lo , hi ) );
+    sumLo = _mm_add_epi32( sumLo , _mm_unpacklo_epi16( lo , hi ) );
+    src += srcStride;
+  }
+  sumHi = _mm_srai_epi32( _mm_add_epi32( sumHi , mmOffset ) , shift );
+  sumLo = _mm_srai_epi32( _mm_add_epi32( sumLo , mmOffset ) , shift );
+  return( _mm_packs_epi32( sumLo , sumHi ) );
+}
+
+inline __m128i simdInterpolateLuma2P4( Short const *src , Int srcStride , __m128i *mmCoeff , const __m128i & mmOffset , Int shift )
+{
+  __m128i sumHi = _mm_setzero_si128();
+  __m128i sumLo = _mm_setzero_si128();
+  for( Int n = 0 ; n < 2 ; n++ )
+  {
+    __m128i mmPix = _mm_loadl_epi64( ( __m128i* )src );
+    __m128i hi = _mm_mulhi_epi16( mmPix , mmCoeff[n] );
+    __m128i lo = _mm_mullo_epi16( mmPix , mmCoeff[n] );
+    sumHi = _mm_add_epi32( sumHi , _mm_unpackhi_epi16( lo , hi ) );
+    sumLo = _mm_add_epi32( sumLo , _mm_unpacklo_epi16( lo , hi ) );
+    src += srcStride;
+  }
+  sumHi = _mm_srai_epi32( _mm_add_epi32( sumHi , mmOffset ) , shift );
+  sumLo = _mm_srai_epi32( _mm_add_epi32( sumLo , mmOffset ) , shift );
+  return( _mm_packs_epi32( sumLo , sumHi ) );
+}
+
+inline __m128i simdClip3( __m128i mmMin , __m128i mmMax , __m128i mmPix )
+{
+  __m128i mmMask = _mm_cmpgt_epi16( mmPix , mmMin );
+  mmPix = _mm_or_si128( _mm_and_si128( mmMask , mmPix ) , _mm_andnot_si128( mmMask , mmMin ) );
+  mmMask = _mm_cmplt_epi16( mmPix , mmMax );
+  mmPix = _mm_or_si128( _mm_and_si128( mmMask , mmPix ) , _mm_andnot_si128( mmMask , mmMax ) );
+  return( mmPix );
+}
+#endif
+
+#if NH_3D
 const Short TComInterpolationFilter::m_lumaFilterARP[4][NTAPS_LUMA_ARP] =
 {
@@ -240,4 +344,135 @@
   }
 
+#if VECTOR_CODING__INTERPOLATION_FILTER && (RExt__HIGH_BIT_DEPTH_SUPPORT==0)
+  if( bitDepth <= 10 )
+  {
+    if( N == 8 && !( width & 0x07 ) )
+    {
+      Short minVal = 0;
+      __m128i mmOffset = _mm_set1_epi32( offset );
+      __m128i mmCoeff[8];
+      __m128i mmMin = _mm_set1_epi16( minVal );
+      __m128i mmMax = _mm_set1_epi16( maxVal );
+      for( Int n = 0 ; n < 8 ; n++ )
+        mmCoeff[n] = _mm_set1_epi16( c[n] );
+      for( row = 0 ; row < height ; row++ )
+      {
+        for( col = 0 ; col < width ; col += 8 )
+        {
+          __m128i mmFiltered = simdInterpolateLuma8( src + col , cStride , mmCoeff , mmOffset , shift );
+          if( isLast )
+          {
+            mmFiltered = simdClip3( mmMin , mmMax , mmFiltered );
+          }
+          _mm_storeu_si128( ( __m128i * )( dst + col ) , mmFiltered );
+        }
+        src += srcStride;
+        dst += dstStride;
+      }
+      return;
+    }
+    else if( N == 8 && !( width & 0x03 ) )
+    {
+      Short minVal = 0;
+      __m128i mmOffset = _mm_set1_epi32( offset );
+      __m128i mmCoeff[8];
+      __m128i mmMin = _mm_set1_epi16( minVal );
+      __m128i mmMax = _mm_set1_epi16( maxVal );
+      for( Int n = 0 ; n < 8 ; n++ )
+        mmCoeff[n] = _mm_set1_epi16( c[n] );
+      for( row = 0 ; row < height ; row++ )
+      {
+        for( col = 0 ; col < width ; col += 4 )
+        {
+          __m128i mmFiltered = simdInterpolateLuma4( src + col , cStride , mmCoeff , mmOffset , shift );
+          if( isLast )
+          {
+            mmFiltered = simdClip3( mmMin , mmMax , mmFiltered );
+          }
+          _mm_storel_epi64( ( __m128i * )( dst + col ) , mmFiltered );
+        }
+        src += srcStride;
+        dst += dstStride;
+      }
+      return;
+    }
+    else if( N == 4 && !( width & 0x03 ) )
+    {
+      Short minVal = 0;
+      __m128i mmOffset = _mm_set1_epi32( offset );
+      __m128i mmCoeff[8];
+      __m128i mmMin = _mm_set1_epi16( minVal );
+      __m128i mmMax = _mm_set1_epi16( maxVal );
+      for( Int n = 0 ; n < 4 ; n++ )
+        mmCoeff[n] = _mm_set1_epi16( c[n] );
+      for( row = 0 ; row < height ; row++ )
+      {
+        for( col = 0 ; col < width ; col += 4 )
+        {
+          __m128i mmFiltered = simdInterpolateChroma4( src + col , cStride , mmCoeff , mmOffset , shift );
+          if( isLast )
+          {
+            mmFiltered = simdClip3( mmMin , mmMax , mmFiltered );
+          }
+          _mm_storel_epi64( ( __m128i * )( dst + col ) , mmFiltered );
+        }
+        src += srcStride;
+        dst += dstStride;
+      }
+      return;
+    }
+    else if( N == 2 && !( width & 0x07 ) )
+    {
+      Short minVal = 0;
+      __m128i mmOffset = _mm_set1_epi32( offset );
+      __m128i mmCoeff[2];
+      __m128i mmMin = _mm_set1_epi16( minVal );
+      __m128i mmMax = _mm_set1_epi16( maxVal );
+      for( Int n = 0 ; n < 2 ; n++ )
+        mmCoeff[n] = _mm_set1_epi16( c[n] );
+      for( row = 0 ; row < height ; row++ )
+      {
+        for( col = 0 ; col < width ; col += 8 )
+        {
+          __m128i mmFiltered = simdInterpolateLuma2P8( src + col , cStride , mmCoeff , mmOffset , shift );
+          if( isLast )
+          {
+            mmFiltered = simdClip3( mmMin , mmMax , mmFiltered );
+          }
+          _mm_storeu_si128( ( __m128i * )( dst + col ) , mmFiltered );
+        }
+        src += srcStride;
+        dst += dstStride;
+      }
+      return;
+    }
+    else if( N == 2 && !( width & 0x03 ) )
+    {
+      Short minVal = 0;
+      __m128i mmOffset = _mm_set1_epi32( offset );
+      __m128i mmCoeff[8];
+      __m128i mmMin = _mm_set1_epi16( minVal );
+      __m128i mmMax = _mm_set1_epi16( maxVal );
+      for( Int n = 0 ; n < 2 ; n++ )
+        mmCoeff[n] = _mm_set1_epi16( c[n] );
+      for( row = 0 ; row < height ; row++ )
+      {
+        for( col = 0 ; col < width ; col += 4 )
+        {
+          __m128i mmFiltered = simdInterpolateLuma2P4( src + col , cStride , mmCoeff , mmOffset , shift );
+          if( isLast )
+          {
+            mmFiltered = simdClip3( mmMin , mmMax , mmFiltered );
+          }
+          _mm_storel_epi64( ( __m128i * )( dst + col ) , mmFiltered );
+        }
+        src += srcStride;
+        dst += dstStride;
+      }
+      return;
+    }
+  }
+#endif
+
   for (row = 0; row < height; row++)
   {
@@ -360,5 +595,5 @@
  * \param  bitDepth   Bit depth
  */
-#if NH_3D_ARP
+#if NH_3D
 Void TComInterpolationFilter::filterHor(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast, const ChromaFormat fmt, const Int bitDepth, Bool filterType )
 #else
@@ -374,5 +609,5 @@
   {
     assert(frac >= 0 && frac < LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
-#if NH_3D_ARP
+#if NH_3D
     if(filterType)
     {
@@ -383,5 +618,5 @@
 #endif
     filterHor<NTAPS_LUMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isLast, m_lumaFilter[frac]);
-#if NH_3D_ARP
+#if NH_3D
     }
 #endif
@@ -392,5 +627,5 @@
     const UInt csx = getComponentScaleX(compID, fmt);
     assert(frac >=0 && csx<2 && (frac<<(1-csx)) < CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
-#if NH_3D_ARP
+#if NH_3D
     if(filterType)
     {
@@ -401,5 +636,5 @@
 #endif
     filterHor<NTAPS_CHROMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isLast, m_chromaFilter[frac<<(1-csx)]);
-#if NH_3D_ARP
+#if NH_3D
     }
 #endif
@@ -424,5 +659,5 @@
  * \param  bitDepth   Bit depth
  */
-#if NH_3D_ARP
+#if NH_3D
 Void TComInterpolationFilter::filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth, Bool filterType )
 #else
@@ -437,5 +672,5 @@
   {
     assert(frac >= 0 && frac < LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
-#if NH_3D_ARP
+#if NH_3D
     if(filterType)
     {
@@ -445,6 +680,6 @@
     {
 #endif
-    filterVer<NTAPS_LUMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilter[frac]);
-#if NH_3D_ARP
+      filterVer<NTAPS_LUMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilter[frac]);
+#if NH_3D
     }
 #endif
@@ -455,5 +690,5 @@
     const UInt csy = getComponentScaleY(compID, fmt);
     assert(frac >=0 && csy<2 && (frac<<(1-csy)) < CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
-#if NH_3D_ARP
+#if NH_3D
     if(filterType)
     {
@@ -463,9 +698,9 @@
     {
 #endif
-    filterVer<NTAPS_CHROMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilter[frac<<(1-csy)]);
-#if NH_3D_ARP
-    }
-#endif
-    }
-    }
+      filterVer<NTAPS_CHROMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilter[frac<<(1-csy)]);
+#if NH_3D
+    }
+#endif
+  }
+}
 //! \}
Index: /trunk/source/Lib/TLibCommon/TComInterpolationFilter.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -45,5 +45,5 @@
 //! \{
 
-#if NH_3D_ARP
+#if NH_3D
 #define NTAPS_LUMA_ARP    2 ///< Number of taps for luma
 #define NTAPS_CHROMA_ARP  2 ///< Number of taps for chroma
@@ -63,5 +63,5 @@
   static const TFilterCoeff m_lumaFilter[LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS][NTAPS_LUMA];     ///< Luma filter taps
   static const TFilterCoeff m_chromaFilter[CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS][NTAPS_CHROMA]; ///< Chroma filter taps
-#if NH_3D_ARP
+#if NH_3D
   static const Short m_lumaFilterARP  [4][NTAPS_LUMA_ARP];     ///< Luma filter taps for ARP
   static const Short m_chromaFilterARP[8][NTAPS_CHROMA_ARP];   ///< Chroma filter taps for ARP
@@ -82,5 +82,5 @@
   ~TComInterpolationFilter() {}
 
-#if NH_3D_ARP
+#if NH_3D
   Void filterHor(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac,               Bool isLast, const ChromaFormat fmt, const Int bitDepth , Bool filterType = false );
 #else
@@ -88,5 +88,5 @@
 #endif
 
-#if NH_3D_ARP
+#if NH_3D
   Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac,               Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth , Bool filterType = false );
 #else
Index: /trunk/source/Lib/TLibCommon/TComList.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComList.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComList.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComLoopFilter.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -561,5 +561,5 @@
         Pel        *piTmpSrc                      = piSrc;
   const TComSPS    &sps                           = *(pcCU->getSlice()->getSPS());
-  const Bool        ppsTransquantBypassEnableFlag = pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag();
+  const Bool        ppsTransquantBypassEnabledFlag = pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag();
   const Int         bitDepthLuma                  = sps.getBitDepth(CHANNEL_TYPE_LUMA);
   const Bool        lfCrossSliceBoundaryFlag      = pcCU->getSlice()->getLFCrossSliceBoundaryFlag();
@@ -644,5 +644,5 @@
         Int d =  d0 + d3;
 
-        if (bPCMFilter || ppsTransquantBypassEnableFlag)
+        if (bPCMFilter || ppsTransquantBypassEnabledFlag)
         {
           // Check if each of PUs is I_PCM with LF disabling
@@ -769,5 +769,5 @@
       iQP_P = pcCUP->getQP(uiPartPIdx);
 
-      if (bPCMFilter || pcCU->getSlice()->getPPS()->getTransquantBypassEnableFlag())
+      if (bPCMFilter || pcCU->getSlice()->getPPS()->getTransquantBypassEnabledFlag())
       {
         // Check if each of PUs is I_PCM with LF disabling
Index: /trunk/source/Lib/TLibCommon/TComLoopFilter.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComLoopFilter.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComLoopFilter.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComMotionInfo.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -40,5 +40,5 @@
 #include "assert.h"
 #include <stdlib.h>
-#if NH_3D_SPIVMP
+#if NH_3D
 #include "TComDataCU.h"
 #include "TComPic.h"
@@ -330,5 +330,5 @@
 }
 
-#if NH_3D_SPIVMP
+#if NH_3D
 Void TComCUMvField::setMvFieldSP( TComDataCU* pcCU, UInt uiAbsPartIdx, TComMvField cMvField, Int iWidth, Int iHeight  )
 {
@@ -358,4 +358,29 @@
  * \param scale      Factor by which to subsample motion information
  */
+#if REDUCED_ENCODER_MEMORY
+Void TComCUMvField::compress(SChar *pePredMode, const SChar* pePredModeSource, const Int scale, const TComCUMvField &source)
+{
+  const Int numSubpartsWithIdenticalMotion = scale * scale;
+  assert( numSubpartsWithIdenticalMotion > 0 && numSubpartsWithIdenticalMotion <= m_uiNumPartition);
+  assert(source.m_uiNumPartition == m_uiNumPartition);
+
+  for ( Int partIdx = 0; partIdx < m_uiNumPartition; partIdx += numSubpartsWithIdenticalMotion )
+  {
+    TComMv cMv(0,0);
+    Int iRefIdx = 0;
+
+    cMv = source.m_pcMv[ partIdx ];
+    PredMode predMode = static_cast<PredMode>( pePredModeSource[ partIdx ] );
+    iRefIdx = source.m_piRefIdx[ partIdx ];
+    for ( Int i = 0; i < numSubpartsWithIdenticalMotion; i++ )
+    {
+      m_pcMv[ partIdx + i ] = cMv;
+      pePredMode[ partIdx + i ] = predMode;
+      m_piRefIdx[ partIdx + i ] = iRefIdx;
+    }
+  }
+}
+#else
+
 Void TComCUMvField::compress(SChar* pePredMode, Int scale)
 {
@@ -379,4 +404,5 @@
   }
 }
+#endif
 
 #if NH_MV
@@ -405,5 +431,5 @@
 }
 
-#if NH_3D_MLC
+#if NH_3D
 Void TComMotionCand::print( Int i )
 {
Index: /trunk/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -51,5 +51,5 @@
 // ====================================================================================================================
 
-#if NH_3D_SPIVMP
+#if NH_3D
 class TComDataCU;
 #endif
@@ -59,13 +59,14 @@
   TComMv m_acMvCand[ AMVP_MAX_NUM_CANDS ];  ///< array of motion vector predictor candidates
   Int    iN;                                ///< number of motion vector predictor candidates
+#if MCTS_ENC_CHECK
+  UInt   numSpatialMVPCandidates;
+#endif
 } AMVPInfo;
 
-#if NH_3D_NBDV
+#if NH_3D
 typedef struct _DisCand 
 {
   TComMv m_acNBDV;              // DV from NBDV
-#if NH_3D_NBDV_REF 
   TComMv m_acDoNBDV;            // DV from DoNBDV
-#endif  
   Int    m_aVIdxCan;            // View order index (the same with the NBDV and the DoNBDV)
 } DisInfo;
@@ -108,5 +109,5 @@
   Int getHor   () const { return  m_acMv.getHor(); }
   Int getVer   () const { return  m_acMv.getVer(); }
-#if NH_3D_IV_MERGE
+#if NH_3D
   Bool operator== ( const TComMvField& rcMv ) const
   {
@@ -168,8 +169,6 @@
   Void    setAllRefIdx ( Int iRefIdx,                 PartSize eMbMode, Int iPartAddr, UInt uiDepth, Int iPartIdx=0 );
   Void    setAllMvField( TComMvField const & mvField, PartSize eMbMode, Int iPartAddr, UInt uiDepth, Int iPartIdx=0 );
-#if NH_3D_SPIVMP
+#if NH_3D
   Void    setMvFieldSP ( TComDataCU* pcCU, UInt uiAbsPartIdx, TComMvField cMvField, Int iWidth, Int iHeight  );
-#endif
-#if NH_3D_VSP
   Void    setMv         ( Int iIdx, TComMv const & rcMv ) { m_pcMv[iIdx] = rcMv; }
   Void    setRefIdx     ( Int iIdx, Int iRefIdx )         { m_piRefIdx[iIdx] = iRefIdx; }
@@ -188,5 +187,9 @@
   }
   
+#if REDUCED_ENCODER_MEMORY
+  Void compress(SChar *pePredMode, const SChar* pePredModeSource, const Int scale, const TComCUMvField &source);
+#else
   Void compress(SChar* pePredMode, Int scale);
+#endif
 #if NH_MV
   Void print   (SChar* pePredMode);
@@ -196,5 +199,5 @@
 //! \}
 
-#if NH_3D_MLC
+#if NH_3D
 /// class for container of merge candidate
 class TComMotionCand
@@ -204,10 +207,6 @@
   TComMvField           m_cMvField[2];
   UChar                 m_uDir;
-#if NH_3D_VSP
   Int                   m_iVspFlag;
-#endif
-#if NH_3D_SPIVMP
   Bool                  m_bSPIVMPFlag;
-#endif
 
 public:
@@ -216,10 +215,6 @@
     m_bAvailable = false;
     m_uDir = 0;
-#if NH_3D_VSP
     m_iVspFlag = 0;
-#endif
-#if NH_3D_SPIVMP
     m_bSPIVMPFlag = false;
-#endif
   }
 
@@ -235,22 +230,11 @@
     m_bAvailable = false;
     m_uDir = 0;
-#if NH_3D_VSP
     m_iVspFlag = 0;
-#endif
-#if NH_3D_SPIVMP
     m_bSPIVMPFlag = false;
-#endif
     m_cMvField[0].setMvField(cZeroMv, NOT_VALID);
     m_cMvField[1].setMvField(cZeroMv, NOT_VALID);
   }
 
-  Void setCand(TComMvField* pcMvFieldNeighbours, UChar uhInterDirNeighbours
-#if NH_3D_VSP
-    , Int vspFlag
-#endif
-#if NH_3D_SPIVMP
-    , Bool bSPIVMPFlag
-#endif
-    )
+  Void setCand(TComMvField* pcMvFieldNeighbours, UChar uhInterDirNeighbours, Int vspFlag, Bool bSPIVMPFlag )
   {
     m_bAvailable = true;
@@ -258,35 +242,17 @@
     m_cMvField[1] = pcMvFieldNeighbours[1];
     m_uDir = uhInterDirNeighbours;
-#if NH_3D_VSP
     m_iVspFlag = vspFlag;
-#endif
-#if NH_3D_SPIVMP
     m_bSPIVMPFlag = bSPIVMPFlag;
-#endif
-  }
-  
-  Void getCand(Int iCount, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours
-#if NH_3D_VSP
-    , Int* vspFlag
-#endif
-#if NH_3D_SPIVMP
-    , Bool* pbSPIVMPFlag
-#endif
-    )
+  }
+  
+  Void getCand(Int iCount, TComMvField* pcMvFieldNeighbours, UChar* puhInterDirNeighbours, Int* vspFlag , Bool* pbSPIVMPFlag )
   {
     pcMvFieldNeighbours[iCount<<1] = m_cMvField[0];
     pcMvFieldNeighbours[(iCount<<1) + 1] = m_cMvField[1];
     puhInterDirNeighbours[iCount] = m_uDir;
-#if NH_3D_VSP
     vspFlag[iCount] = m_iVspFlag;
-#endif
-#if NH_3D_SPIVMP
     pbSPIVMPFlag[iCount] = m_bSPIVMPFlag;
-#endif
-  }
-
-
+  }
   Void print( Int i );
-
 };
 
Index: /trunk/source/Lib/TLibCommon/TComMv.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComMv.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComMv.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -57,5 +57,5 @@
   Short m_iHor;     ///< horizontal component of motion vector
   Short m_iVer;     ///< vertical component of motion vector
-#if NH_3D_NBDV
+#if NH_3D
   Bool  m_bIDV;       
   Short m_iIDVHor;    
@@ -72,5 +72,5 @@
   m_iHor(0),
   m_iVer(0)
-#if NH_3D_NBDV
+#if NH_3D
   , m_bIDV(false)
   , m_iIDVHor(0)
@@ -84,5 +84,5 @@
   m_iHor(iHor),
   m_iVer(iVer)
- #if NH_3D_NBDV
+ #if NH_3D
   , m_bIDV(false)
   , m_iIDVHor(0)
@@ -100,5 +100,5 @@
   Void  setHor    ( Short i )                   { m_iHor = i;                               }
   Void  setVer    ( Short i )                   { m_iVer = i;                               }
-#if NH_3D_NBDV
+#if NH_3D
   Void  setZero   ()                            { m_iHor = m_iVer = 0; m_bIDV = false; m_iIDVHor = m_iIDVVer = 0; m_iIDVVId = 0;  }
   Void   setIDVHor  (Short i)                    {m_iIDVHor = i;}
@@ -117,5 +117,5 @@
   Int   getAbsHor () const { return abs( m_iHor );   }
   Int   getAbsVer () const { return abs( m_iVer );   }
-#if NH_3D_NBDV
+#if NH_3D
   Short getIDVHor () const { return m_iIDVHor;       }
   Short getIDVVer () const { return m_iIDVVer;       }
Index: /trunk/source/Lib/TLibCommon/TComPattern.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPattern.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPattern.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -74,40 +74,43 @@
 
 // ====================================================================================================================
-// Public member functions (TComPatternParam)
-// ====================================================================================================================
-
-/** 
- \param  piTexture     pixel data
- \param  iRoiWidth     pattern width
- \param  iRoiHeight    pattern height
- \param  iStride       buffer stride
- \param  bitDepth      bit depth
- */
-Void TComPatternParam::setPatternParamPel ( Pel* piTexture,
-                                           Int iRoiWidth,
-                                           Int iRoiHeight,
-                                           Int iStride,
-                                           Int bitDepth
-                                           )
-{
-  m_piROIOrigin    = piTexture;
-  m_iROIWidth      = iRoiWidth;
-  m_iROIHeight     = iRoiHeight;
-  m_iPatternStride = iStride;
-  m_bitDepth       = bitDepth;
-}
-
-// ====================================================================================================================
 // Public member functions (TComPattern)
 // ====================================================================================================================
 
+#if MCTS_ENC_CHECK
+Void TComPattern::initPattern(Pel* piY,
+                              Int roiWidth,
+                              Int roiHeight,
+                              Int stride,
+                              Int bitDepthLuma,
+                              Int roiPosX,
+                              Int roiPosY)
+#else
 Void TComPattern::initPattern (Pel* piY,
-                               Int iRoiWidth,
-                               Int iRoiHeight,
-                               Int iStride,
+                               Int roiWidth,
+                               Int roiHeight,
+                               Int stride,
                                Int bitDepthLuma)
-{
-  m_cPatternY. setPatternParamPel( piY,  iRoiWidth, iRoiHeight, iStride, bitDepthLuma);
-}
+#endif
+{
+  m_piROIOrigin = piY;
+  m_roiWidth = roiWidth;
+  m_roiHeight = roiHeight;
+  m_patternStride = stride;
+  m_bitDepth = bitDepthLuma;
+#if MCTS_ENC_CHECK
+  m_roiPosX       = roiPosX;
+  m_roiPosY       = roiPosY;
+#endif
+}
+
+#if MCTS_ENC_CHECK
+Void TComPattern::setTileBorders(Int tileLeftTopPelPosX, Int tileLeftTopPelPosY, Int tileRightBottomPelPosX, Int tileRightBottomPelPosY)
+{
+  m_tileLeftTopPelPosX = tileLeftTopPelPosX;
+  m_tileLeftTopPelPosY = tileLeftTopPelPosY;
+  m_tileRightBottomPelPosX = tileRightBottomPelPosX;
+  m_tileRightBottomPelPosY = tileRightBottomPelPosY;
+}
+#endif
 
 
Index: /trunk/source/Lib/TLibCommon/TComPattern.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPattern.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPattern.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -52,63 +52,75 @@
 class TComTU;
 
-/// neighbouring pixel access class for one component
-class TComPatternParam
+/// neighbouring pixel access class for all components
+class TComPattern
 {
 private:
   Pel*  m_piROIOrigin;
+  Int   m_roiWidth;
+  Int   m_roiHeight;
+  Int   m_patternStride;
+  Int   m_bitDepth;
+
+#if MCTS_ENC_CHECK  
+  Int   m_roiPosX;
+  Int   m_roiPosY;
+  Int   m_tileLeftTopPelPosX;
+  Int   m_tileLeftTopPelPosY;
+  Int   m_tileRightBottomPelPosX;
+  Int   m_tileRightBottomPelPosY;
+#endif
 
 public:
-  Int   m_iROIWidth;
-  Int   m_iROIHeight;
-  Int   m_iPatternStride;
-  Int   m_bitDepth;
+  // ROI & pattern information, (ROI = &pattern[AboveOffset][LeftOffset])
+  Int   getROIYWidth() const      { return m_roiWidth;       }
+  Int   getROIYHeight() const     { return m_roiHeight;      }
+  Int   getPatternLStride() const { return m_patternStride;  }
+  Int   getBitDepthY() const      { return m_bitDepth;       }
+#if MCTS_ENC_CHECK
+  Int   getROIYPosX() const       { return m_roiPosX; }
+  Int   getROIYPosY() const       { return m_roiPosY; }
 
-  /// return starting position of ROI (ROI = &pattern[AboveOffset][LeftOffset])
-  __inline Pel*  getROIOrigin()
+  Int   getTileLeftTopPelPosX() const { return m_tileLeftTopPelPosX; }
+  Int   getTileLeftTopPelPosY() const { return m_tileLeftTopPelPosY; }
+  Int   getTileRightBottomPelPosX() const { return m_tileRightBottomPelPosX; }
+  Int   getTileRightBottomPelPosY() const { return m_tileRightBottomPelPosY; }
+#endif
+
+  __inline Pel*  getROIY()
   {
     return  m_piROIOrigin;
   }
-  __inline const Pel*  getROIOrigin() const
+  __inline const Pel*  getROIY() const
   {
     return  m_piROIOrigin;
   }
 
-  /// set parameters from Pel buffer for accessing neighbouring pixels
-  Void setPatternParamPel( Pel* piTexture, Int iRoiWidth, Int iRoiHeight, Int iStride, Int bitDepth );
-};
+#if NH_3D
+  Bool              m_bICFlag;
+  Bool              m_bSDCMRSADFlag;
 
-/// neighbouring pixel access class for all components
-class TComPattern
-{
-private:
-  TComPatternParam  m_cPatternY;
-//  TComPatternParam  m_cPatternCb;
-  //TComPatternParam  m_cPatternCr;
-#if NH_3D_IC
-  Bool              m_bICFlag;
-#endif
-#if NH_3D_SDC_INTER
-  Bool              m_bSDCMRSADFlag;
+  Bool  getICFlag()               const { return m_bICFlag; }
+  Void  setICFlag( Bool bICFlag ) { m_bICFlag = bICFlag; }
+  Bool  getSDCMRSADFlag()         const { return m_bSDCMRSADFlag; }
+  Void  setSDCMRSADFlag( Bool bSDCMRSADFlag )    { m_bSDCMRSADFlag = bSDCMRSADFlag; }
 #endif
 
 
-public:
+  TComPattern()
+  : m_piROIOrigin(NULL)
+  , m_roiWidth(0)
+  , m_roiHeight(0)
+  , m_patternStride(0)
+  , m_bitDepth(0)
+#if MCTS_ENC_CHECK
+  , m_roiPosX(0)
+  , m_roiPosY(0)
+  , m_tileLeftTopPelPosX(0)
+  , m_tileLeftTopPelPosY(0)
+  , m_tileRightBottomPelPosX(0)
+  , m_tileRightBottomPelPosY(0)
+#endif
+  {};
 
-  // ROI & pattern information, (ROI = &pattern[AboveOffset][LeftOffset])
-  Pel*  getROIY()                 { return m_cPatternY.getROIOrigin();    }
-  const Pel*  getROIY() const     { return m_cPatternY.getROIOrigin();    }
-  Int   getROIYWidth() const      { return m_cPatternY.m_iROIWidth;       }
-  Int   getROIYHeight() const     { return m_cPatternY.m_iROIHeight;      }
-  Int   getPatternLStride() const { return m_cPatternY.m_iPatternStride;  }
-  Int   getBitDepthY() const      { return m_cPatternY.m_bitDepth;        }
-
-#if NH_3D_IC
-  Bool  getICFlag()               const { return m_bICFlag; }
-  Void  setICFlag( Bool bICFlag ) { m_bICFlag = bICFlag; }
-#endif
-#if NH_3D_SDC_INTER
-  Bool  getSDCMRSADFlag()         const { return m_bSDCMRSADFlag; }
-  Void  setSDCMRSADFlag( Bool bSDCMRSADFlag )    { m_bSDCMRSADFlag = bSDCMRSADFlag; }
-#endif
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -117,5 +129,10 @@
 
   /// set parameters from Pel buffers for accessing neighbouring pixels
-  Void initPattern( Pel* piY, Int iRoiWidth, Int iRoiHeight, Int iStride, Int bitDepthLuma );
+#if MCTS_ENC_CHECK
+  Void initPattern(Pel* piY, Int roiWidth, Int roiHeight, Int stride, Int bitDepthLuma, Int roiPosX, Int roiPosY);
+  Void setTileBorders(Int tileLeftTopPelPosX, Int tileLeftTopPelPosY, Int tileRightBottomPelPosX, Int tileRightBottomPelPosY);
+#else
+  Void initPattern(Pel* piY, Int roiWidth, Int roiHeight, Int stride, Int bitDepthLuma);
+#endif
 };
 
